
_Debounce:

;MatrixKeypad.c,27 :: 		void Debounce(){
;MatrixKeypad.c,28 :: 		Delay_ms(50);
	MOVLW      9
	MOVWF      R12
	MOVLW      28
	MOVWF      R13
L_Debounce0:
	DECFSZ     R13, 1
	GOTO       L_Debounce0
	DECFSZ     R12, 1
	GOTO       L_Debounce0
	NOP
;MatrixKeypad.c,29 :: 		}
L_end_Debounce:
	RETURN
; end of _Debounce

_Get_Key:

;MatrixKeypad.c,31 :: 		char Get_Key(){
;MatrixKeypad.c,33 :: 		PORTB = 0b00001110;
	MOVLW      14
	MOVWF      PORTB+0
;MatrixKeypad.c,34 :: 		if (!Col1){
	BTFSC      RB4_bit+0, 4
	GOTO       L_Get_Key1
;MatrixKeypad.c,35 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,36 :: 		return 0x31;
	MOVLW      49
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,37 :: 		}
L_Get_Key1:
;MatrixKeypad.c,38 :: 		if (!Col2){
	BTFSC      RB5_bit+0, 5
	GOTO       L_Get_Key2
;MatrixKeypad.c,39 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,40 :: 		return 0x32;
	MOVLW      50
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,41 :: 		}
L_Get_Key2:
;MatrixKeypad.c,42 :: 		if (!Col3){
	BTFSC      RB6_bit+0, 6
	GOTO       L_Get_Key3
;MatrixKeypad.c,43 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,44 :: 		return 0x33;
	MOVLW      51
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,45 :: 		}
L_Get_Key3:
;MatrixKeypad.c,46 :: 		if (!Col4){
	BTFSC      RB7_bit+0, 7
	GOTO       L_Get_Key4
;MatrixKeypad.c,47 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,48 :: 		return 0x41;
	MOVLW      65
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,49 :: 		}
L_Get_Key4:
;MatrixKeypad.c,51 :: 		PORTB = 0b00001101;
	MOVLW      13
	MOVWF      PORTB+0
;MatrixKeypad.c,52 :: 		if (!Col1){
	BTFSC      RB4_bit+0, 4
	GOTO       L_Get_Key5
;MatrixKeypad.c,53 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,54 :: 		return 0x34;
	MOVLW      52
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,55 :: 		}
L_Get_Key5:
;MatrixKeypad.c,56 :: 		if (!Col2){
	BTFSC      RB5_bit+0, 5
	GOTO       L_Get_Key6
;MatrixKeypad.c,57 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,58 :: 		return 0x35;
	MOVLW      53
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,59 :: 		}
L_Get_Key6:
;MatrixKeypad.c,60 :: 		if (!Col3){
	BTFSC      RB6_bit+0, 6
	GOTO       L_Get_Key7
;MatrixKeypad.c,61 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,62 :: 		return 0x36;
	MOVLW      54
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,63 :: 		}
L_Get_Key7:
;MatrixKeypad.c,64 :: 		if (!Col4){
	BTFSC      RB7_bit+0, 7
	GOTO       L_Get_Key8
;MatrixKeypad.c,65 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,66 :: 		return 0x42;
	MOVLW      66
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,67 :: 		}
L_Get_Key8:
;MatrixKeypad.c,69 :: 		PORTB = 0b00001011;
	MOVLW      11
	MOVWF      PORTB+0
;MatrixKeypad.c,70 :: 		if (!Col1){
	BTFSC      RB4_bit+0, 4
	GOTO       L_Get_Key9
;MatrixKeypad.c,71 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,72 :: 		return 0x37;
	MOVLW      55
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,73 :: 		}
L_Get_Key9:
;MatrixKeypad.c,74 :: 		if (!Col2){
	BTFSC      RB5_bit+0, 5
	GOTO       L_Get_Key10
;MatrixKeypad.c,75 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,76 :: 		return 0x38;
	MOVLW      56
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,77 :: 		}
L_Get_Key10:
;MatrixKeypad.c,78 :: 		if (!Col3){
	BTFSC      RB6_bit+0, 6
	GOTO       L_Get_Key11
;MatrixKeypad.c,79 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,80 :: 		return 0x39;
	MOVLW      57
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,81 :: 		}
L_Get_Key11:
;MatrixKeypad.c,82 :: 		if (!Col4){
	BTFSC      RB7_bit+0, 7
	GOTO       L_Get_Key12
;MatrixKeypad.c,83 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,84 :: 		return 0x43;
	MOVLW      67
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,85 :: 		}
L_Get_Key12:
;MatrixKeypad.c,87 :: 		PORTB = 0b00000111;
	MOVLW      7
	MOVWF      PORTB+0
;MatrixKeypad.c,88 :: 		if (!Col1){
	BTFSC      RB4_bit+0, 4
	GOTO       L_Get_Key13
;MatrixKeypad.c,89 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,90 :: 		return 0x2A;
	MOVLW      42
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,91 :: 		}
L_Get_Key13:
;MatrixKeypad.c,92 :: 		if (!Col2){
	BTFSC      RB5_bit+0, 5
	GOTO       L_Get_Key14
;MatrixKeypad.c,93 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,94 :: 		return 0x30;
	MOVLW      48
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,95 :: 		}
L_Get_Key14:
;MatrixKeypad.c,96 :: 		if (!Col3){
	BTFSC      RB6_bit+0, 6
	GOTO       L_Get_Key15
;MatrixKeypad.c,97 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,98 :: 		return 0x23;
	MOVLW      35
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,99 :: 		}
L_Get_Key15:
;MatrixKeypad.c,100 :: 		if (!Col4){
	BTFSC      RB7_bit+0, 7
	GOTO       L_Get_Key16
;MatrixKeypad.c,101 :: 		Debounce();
	CALL       _Debounce+0
;MatrixKeypad.c,102 :: 		return 0x44;
	MOVLW      68
	MOVWF      R0
	GOTO       L_end_Get_Key
;MatrixKeypad.c,103 :: 		}
L_Get_Key16:
;MatrixKeypad.c,104 :: 		return ' ';
	MOVLW      32
	MOVWF      R0
;MatrixKeypad.c,106 :: 		}
L_end_Get_Key:
	RETURN
; end of _Get_Key

_main:

;MatrixKeypad.c,108 :: 		void main() {
;MatrixKeypad.c,109 :: 		char key[] = " ";
	MOVLW      32
	MOVWF      main_key_L0+0
	CLRF       main_key_L0+1
;MatrixKeypad.c,110 :: 		TRISA  = 0b00100000;   // PORTA output except RA5
	MOVLW      32
	MOVWF      TRISA+0
;MatrixKeypad.c,111 :: 		TRISB  = 0b11110000;   // R1-R4 output, C1-C4 input
	MOVLW      240
	MOVWF      TRISB+0
;MatrixKeypad.c,112 :: 		ANSELA = 0x00;         // Disable any analog functions in PORTA
	CLRF       ANSELA+0
;MatrixKeypad.c,113 :: 		ANSELB = 0x00;         // Disable any analog functions in PORTB
	CLRF       ANSELB+0
;MatrixKeypad.c,114 :: 		OPTION_REG = 0x00;
	CLRF       OPTION_REG+0
;MatrixKeypad.c,115 :: 		PORTB  = 0b00001111;   // All rows equal to 1
	MOVLW      15
	MOVWF      PORTB+0
;MatrixKeypad.c,116 :: 		Lcd_Init();
	CALL       _Lcd_Init+0
;MatrixKeypad.c,117 :: 		Lcd_Cmd(_LCD_CLEAR);             // CLEAR display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;MatrixKeypad.c,118 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);        // Cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;MatrixKeypad.c,119 :: 		Lcd_Out(1,1,message1);           // Write message1 in 1st row
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _message1+0
	MOVWF      FARG_Lcd_Out_text+0
	MOVLW      hi_addr(_message1+0)
	MOVWF      FARG_Lcd_Out_text+1
	CALL       _Lcd_Out+0
;MatrixKeypad.c,120 :: 		WPUB   = 0b11110000;             // RB3-RB7 pull-up enabled
	MOVLW      240
	MOVWF      WPUB+0
;MatrixKeypad.c,121 :: 		do {
L_main17:
;MatrixKeypad.c,122 :: 		key[0] = Get_Key();
	CALL       _Get_Key+0
	MOVF       R0, 0
	MOVWF      main_key_L0+0
;MatrixKeypad.c,123 :: 		if (key[0] != ' ') Lcd_Out(2,7,key);
	MOVF       R0, 0
	XORLW      32
	BTFSC      STATUS+0, 2
	GOTO       L_main20
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      main_key_L0+0
	MOVWF      FARG_Lcd_Out_text+0
	MOVLW      hi_addr(main_key_L0+0)
	MOVWF      FARG_Lcd_Out_text+1
	CALL       _Lcd_Out+0
L_main20:
;MatrixKeypad.c,124 :: 		}while(1);
	GOTO       L_main17
;MatrixKeypad.c,125 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
